;
;

	processor 6502

; encode SYS 2064 ($0810) line
; in BASIC program space
;

	org  $0800

	dc $00 ,$0c, $08, $0a, $00, $9e, $20, $32 
	dc $30, $36, $34, $00, $00, $00, $00, $00

;
; VideoRAM = $0400 - $07e8
;
; $fb = LB Index Conter for VideoRAM
; $fc = HB Index Conter for VideoRAM
;
; Write char into C64 VRAM (textmode)
;

COLUMN = $d3		; BASIC Cursor Column adress, will be automatic updated after each print
ROW    = $d6		; BASIC Cursor Row adress, will be automatic updated after each print

SETCUR = $E50A ; C=0  Cursor setzen / C=1 Cursorposition holen / X= Zeile / Y= Spalte
CHROUT = $AB47	; Zeichen ausgeben
BSOUT  = $ffd2	; Zeichen ausgeben
PRTINT = $BDCD	; 16bit als Int ausgenben
STROUT = $AB1E	; print String 
CLRSCN = $E544	; Clear Screen
GETIN  = $E124 ;F13E	; Get in
INPUT  = $A560	;


CHKKOM = $AEFD	; auf "," pr�fen
FRMEVL = $e257	; Dateinamen holen und setzen
FRMNUM = $AD8A	; Ausdruck holen und auf numerisch pr�fen 
GETADR = $b7f7	; (Akku = H-Byte; Y-Register = L-Byte)
TEXTCOL = $0286 ; Text color

VRAM_START = $0400
VRAM_END   = VRAM_START + 1024

; VideoRAM = $0400 - $0500
; Zero-Page global C64 Pointer $22 - $25
; Zero-Page unused memory $FD - $FE

WHT       = $01		; Textcolor white
TXTROW    = $03		; Init first out row
TXTCOL    = $00		; init first output column
INDEX_LB  = $fb		; LB Index Conter for VideoRAM
INDEX_HB  = $fc		; HB Index Conter for VideoRAM
BYTE      = $fd		; Inter to HEX
COLOR_SAVE  = $FE		; Latch for color
TXTOUT_LB = $22		;
TXTOUT_HB = $23		;
END_LB    = $24		;
END_HB    = $25		;

;INDEX = $fcfb		; Index counter HB->$FC, LB->$fb
INDEX = VRAM_START	; Index counter HB->$FC, LB->$fb
END = VRAM_END		; last address to check



;**********************************
; check Video RAM $400 - $04FF
;**********************************
Init	jsr CLRSCN	; Clear Screen
	clc		; Mode set cursor
	ldx #TXTROW	; Zeile
	ldy #TXTCOL	; Spalte
	jsr SETCUR	; Setze Cursor
	LDA #<txt	;
	sta TXTOUT_HB	;
	LDY #>txt	;
	sta TXTOUT_LB	;
	jsr STROUT	; print 'Version..'
	
T1	jsr CHK_CR	; Check Color RAM
	jsr REP		; print repeat or next
	JSR NEX
W1	jsr GETIN	; get a keystroke
	beq W1		; got no key
	cmp #"R"	; press for repeat?
	beq T1		; do it again
	
T2	jsr CHK_VR	; Check Video RAM
	jsr REP		; print repeat or next
	JSR NEX
W2	jsr GETIN	;
	beq W2		;
	cmp #"R"	;
	beq T2		;
	
T3	jsr CHK_HR	; Check High RAM
	jsr REP		; print repeat or next
	jsr ENDE	; print repeat or next
W3	jsr GETIN	;
	beq W3		;
	cmp #"R"	;
	beq T3		;
	
	rts
	


;**********************************
; check High RAM $C000 - $CFFF
;**********************************
CHK_HR	lda #$00	; set start LB #00
	sta INDEX_LB	; indirect color ram
	lda #$c0	; set start HB #D8
	sta INDEX_HB	; indirect color ram
	lda #$CF	; set highbyte
	sta END_HB	; endpage 
	
	; section check high ram
	lda TEXTCOL
	pha
	lda #WHT
	sta TEXTCOL
	LDA #<txt5	;
	sta TXTOUT_HB	;
	LDY #>txt5	;
	sta TXTOUT_LB	;
	jsr STROUT	; print 'CHECK HIGH RAM'
	
	lda COLUMN	; correct
	clc		; column
	adc #$04	; to +4
	sta COLUMN	; 
	
hchk	ldx ROW		; Zeile
	lda COLUMN	; Spalte
	sec		;
	sbc #$04	; 4 Zeichen abziehen
	tay		; Spalte - 4
	clc		; Mode set cursor
	jsr SETCUR	; Setze Cursor
	
	; print INDEX highbyte as HEX
	lda INDEX_HB	;
	jsr OUTHEX	;
	; print INDEX lowbyte as HEX
	lda INDEX_LB	;
	jsr OUTHEX	;
	
	ldy #$00	;
	lda (INDEX_LB),y;
	tax		;
	lda #%01010101	;
	sta (INDEX_LB),y;
	cmp (INDEX_LB),y;
	bne hrerr1	;
	lda #%10101010	;
	sta (INDEX_LB),y;
	cmp (INDEX_LB),y;
	bne hrerr2	;
	txa		;
	sta (INDEX_LB),y;
	inc INDEX_LB	;
	bne hchk	;
	
	inc INDEX_HB
	lda INDEX_HB
	cmp END_HB
	bmi hchk	; INDEX_HB < END_HB
	beq hchk	; INDEX_HB = END_HB
	jmp hrpass	;
	
hrerr1	sta BYTE
	pla
	sta TEXTCOL
	LDA #<txt1	;
	sta TXTOUT_HB	;
	LDY #>txt1	;
	sta TXTOUT_LB	;
	jsr STROUT	; print 'ERROR PASS #1'
	
	LDA #<txt7	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt7	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' is $'
	
	lda BYTE	; Load saved current value
	jsr OUTHEX	; print HEX value
	LDA #<txt6	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt6	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' SHOULD BE $'
	lda #%01010101	; load pattern #1
	jmp OUTHEX	; print HEX value and bye
	
hrerr2	sta BYTE
	pla
	sta TEXTCOL
	LDA #<txt2	;
	sta TXTOUT_HB	;
	LDY #>txt2	;
	sta TXTOUT_LB	;
	jsr STROUT	; print 'TEST PASSED'
	
	LDA #<txt7	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt7	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' is $'
	
	lda BYTE	; Load saved current value
	jsr OUTHEX	; print HEX value
	LDA #<txt6	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt6	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' SHOULD BE $'
	lda #%10101010	; load pattern #2
	jmp OUTHEX	; print HEX value and bye
	
hrpass	pla
	sta TEXTCOL
	LDA #<txt3	;
	sta TXTOUT_HB	;
	LDY #>txt3	;
	sta TXTOUT_LB	;
	jmp STROUT	; print 'TEST PASSED'

;**********************************
; check Video RAM $400 - $04FF
;**********************************
CHK_VR	lda #$00	; set start LB #00
	sta INDEX_LB	; indirect videoram
	lda #$04	; set start HB #04
	sta INDEX_HB	; indirect videoram
	
	lda TEXTCOL
	pha
	lda #WHT
	sta TEXTCOL
	LDA #<txt0	;
	sta TXTOUT_HB	;
	LDY #>txt0	;
	sta TXTOUT_LB	;
	jsr STROUT	; print 'CHECK RAM...'
	
	lda COLUMN	; correct
	clc		; column
	adc #$04	; to +4
	sta COLUMN	; 
	
cvr0	ldx ROW		; Zeile
	lda COLUMN	; Spalte
	sec		;
	sbc #$04	; 4 Zeichen abziehen
	tay		; Spalte - 4
	clc		; Mode set cursor
	jsr SETCUR	; Setze Cursor
	
	; print INDEX highbyte as HEX
	lda INDEX_HB	;
	jsr OUTHEX	;
	; print INDEX lowbyte as HEX
	lda INDEX_LB	;
	jsr OUTHEX	;
	
	ldy #$00	;
	lda (INDEX_LB),y;
	tax		;
	lda #%01010101	;
	sta (INDEX_LB),y;
	cmp (INDEX_LB),y;
	bne vrerr1	;
	lda #%10101010	;
	sta (INDEX_LB),y;
	cmp (INDEX_LB),y;
	bne vrerr2	;
	txa		;
	sta (INDEX_LB),y;
	inc INDEX_LB	;
	bne cvr0	;
	jmp vrpass
	
vrerr1	sta BYTE
	pla
	sta TEXTCOL
	LDA #<txt1	;
	sta TXTOUT_HB	;
	LDY #>txt1	;
	sta TXTOUT_LB	;
	jsr STROUT	; print 'ERROR PASS #1'
	
	LDA #<txt7	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt7	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' is $'
	
	lda BYTE	; Load saved current value
	jsr OUTHEX	; print HEX value
	LDA #<txt6	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt6	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' SHOULD BE $'
	lda #%01010101	; load pattern #1
	jmp OUTHEX	; print HEX value and bye
	
vrerr2	sta BYTE
	pla
	sta TEXTCOL
	LDA #<txt2	;
	sta TXTOUT_HB	;
	LDY #>txt2	;
	sta TXTOUT_LB	;
	jsr STROUT	; print 'ERROR PASS #2'
	
	LDA #<txt7	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt7	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' is $'
	
	lda BYTE	; Load saved current value
	jsr OUTHEX	; print HEX value
	LDA #<txt6	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt6	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' SHOULD BE $'
	lda #%10101010	; load pattern #2
	jmp OUTHEX	; print HEX value and bye
	
vrpass	pla
	sta TEXTCOL
	LDA #<txt3	;
	sta TXTOUT_HB	;
	LDY #>txt3	;
	sta TXTOUT_LB	;
	jmp STROUT	; print 'TEST PASSED'


;**********************************
; check Color RAM $D800 - $D8FF
;**********************************
CHK_CR	lda #$00	; set start LB #00
	sta INDEX_LB	; indirect color ram
	lda #$d8	; set start HB #D8
	sta INDEX_HB	; indirect color ram
	
	lda TEXTCOL
	pha
	lda #WHT
	sta TEXTCOL
	LDA #<txt4	; HB
	sta TXTOUT_HB	; Text 
	LDY #>txt4	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print 'CHECK COLOR RAM'
	
	lda COLUMN	; correct
	clc		; column
	adc #$04	; to +4
	sta COLUMN	; 
	
colchk	ldx ROW		; Zeile
	lda COLUMN	; Spalte
	sec		;
	sbc #$04	; 4 Zeichen abziehen
	tay		; Spalte - 4
	clc		; Mode set cursor
	jsr SETCUR	; Setze Cursor
	
	; print INDEX highbyte as HEX
	lda INDEX_HB	; print
	jsr OUTHEX	; HEX-value
	; print INDEX lowbyte as HEX
	lda INDEX_LB	; print
	jsr OUTHEX	; HEX-value
	
	ldy #$00	; set indirect to zero
	lda (INDEX_LB),y; load current color value
	sta COLOR_SAVE	; and save
	lda #%00000101	; load pattern #1
	sta (INDEX_LB),y; save
	lda (INDEX_LB),y; 
	and #$0f	; mask low nibble
	cmp #%00000101	; compare with pattern #1
	bne crerr1	; No equal!
	lda #%00001010	; load pattern #2
	sta (INDEX_LB),y; and save
	lda (INDEX_LB),y; load pattern #2
	and #$0f	; mask low nibble
	cmp #%00001010	; compare with pattern #2
	bne crerr2	; No equal!
	lda COLOR_SAVE	; load saved color value
	sta (INDEX_LB),y; and restore 
	inc INDEX_LB	; INDEX++
	bne colchk	; pageend not reached, again....
	jmp crpass	; Check passed
	
crerr1	sta BYTE	; Save current value
	PLA
	STA TEXTCOL
	LDA #<txt1	; HB
	sta TXTOUT_HB	; text
	LDY #>txt1	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print 'ERROR PASS #1'
	
	LDA #<txt7	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt7	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' is $'
	
	lda BYTE	; Load saved current value
	jsr OUTHEX	; print HEX value
	LDA #<txt6	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt6	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' SHOULD BE $'
	lda #%00000101	; load pattern #1
	jmp OUTHEX	; print HEX value and bye
	
crerr2	sta BYTE	; Save current value
	PLA
	STA TEXTCOL
	LDA #<txt2	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt2	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print 'ERROR PASS #2'
	
	LDA #<txt7	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt7	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' is $'
	lda BYTE	; Load saved current value
	jsr OUTHEX	; print HEX value
	
	LDA #<txt6	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt6	; LB
	sta TXTOUT_LB	; Text
	jsr STROUT	; print ' SHOULD BE $'
	lda #%00001010	; load pattern #2
	jmp OUTHEX	; print HEX value and bye
	
crpass	PLA
	STA TEXTCOL
	LDA #<txt3	; HB
	sta TXTOUT_HB	; Text
	LDY #>txt3	; LB
	sta TXTOUT_LB	; Text
	jmp STROUT	; print 'TEST PASSED' and bye


;**************************
; print Akku hex value
;**************************
OUTHEX	tax		;
	and #$f0	; High nibble
	clc		; clear carry
	ror		; rotate one bit right
	ror		; rotate one bit right
	ror		; rotate one bit right
	ror		; rotate one bit right
	jsr NIB2HEX	; print nibble
	txa		; LB
	and #$0f	; Low nibble
	jsr NIB2HEX	; print nibble
	rts


;*********************
;* Akku low Nibble to Hex
;*********************
NIB2HEX cmp #$0a	; Accu >= 10?
	bcs HEX		; Yes
DIGIT	clc		; Accu < 10
	adc #$30	; Accu + $30
	jmp OUT		; print
HEX	clc		;
	adc #$37	; Accu + $37
OUT	jmp BSOUT	; Print Accu and bye


;**************************
; 
;**************************
TXTOUT	ldy #$00
t0	lda (TXTOUT_LB),y ; get char
	beq end		; Text end?
	jsr BSOUT	; print char
	iny		; index next char
	jmp t0		; loop
end	rts		; bye


;**************************
; REPEAT, NEXT and END
;**************************
REP	LDA #<txt8a	;
	sta TXTOUT_HB	;
	LDY #>txt8a	;
	sta TXTOUT_LB	;
	jmp STROUT	; print 'CHOSE (R)EPEAT OR OTHER FOR '

NEX	LDA #<txt8b	;
	sta TXTOUT_HB	;
	LDY #>txt8b	;
	sta TXTOUT_LB	;
	jmp STROUT	; print 'NEXT TEST.'

ENDE	LDA #<txt8c	;
	sta TXTOUT_HB	;
	LDY #>txt8c	;
	sta TXTOUT_LB	;
	jmp STROUT	; print 'END TEST.'


txt  byte "RAM-TEST V1.0 (C) 2017 ANDREAS BUJOK",$0d,0
txt0 byte $0d,"CHECK VIDEO RAM $",0
txt4 byte $0d,"CHECK COLOR RAM $",0
txt5 byte $0d,"CHECK HIGH RAM $",0
txt8a byte $0d,"CHOSE (R)EPEAT OR OTHER FOR ",0
txt8b byte "NEXT TEST.",$0d,0
txt8c byte "END TEST.",$0d,0

txt3 byte $0d,"TEST PASSED",$0d,0
txt1 byte $0d,"ERROR PASS #1.",0
txt2 byte $0d,"ERROR PASS #2.",0
txt6 byte " SHOULD BE $",0
txt7 byte " IS $",0

